Index: /vendors/AGRIF/CMEMS_2020/AGRIF_FILES/modupdate.F90
===================================================================
--- /vendors/AGRIF/CMEMS_2020/AGRIF_FILES/modupdate.F90	(revision 10086)
+++ /vendors/AGRIF/CMEMS_2020/AGRIF_FILES/modupdate.F90	(revision 10087)
@@ -1512,4 +1577,5 @@
                                             tabtemp(:,j),               &
                                             tempC(:,j-lb_child(2)+1),   &
+                                            tempC_indic(:,j-lb_child(2)+1),   &
                                             indmin(1), indmax(1),       &
                                             lb_child(1),ub_child(1),    &
@@ -1519,5 +1585,7 @@
     ENDIF
 !
-    tabtemp_trsp = TRANSPOSE(tabtemp)
+
+    if (to_transpose) tabtemp_trsp = TRANSPOSE(tabtemp)
+
     coeffraf = nint(ds_parent(2)/ds_child(2))
 !
@@ -1564,53 +1632,9 @@
     ENDIF
 !
+
+	
     tempP = TRANSPOSE(tempP_trsp)
 !---------------------------------------------------------------------------------------------------
 end subroutine Agrif_Update_2D_Recursive
-!===================================================================================================
-!
-subroutine Agrif_Update_2D_Recursive_ok ( type_update, &
-                                        tempP, tempC, &
-                                        indmin, indmax,   &
-                                       lb_child, ub_child,                    &
-                                       s_child, s_parent, ds_child, ds_parent )
-!---------------------------------------------------------------------------------------------------
-    INTEGER, DIMENSION(2), intent(in)   :: type_update            !< Type of update (copy or average)
-    INTEGER, DIMENSION(2), intent(in)   :: indmin, indmax
-    INTEGER, DIMENSION(2), intent(in)   :: lb_child, ub_child
-    REAL,    DIMENSION(2), intent(in)   :: s_child,  s_parent
-    REAL,    DIMENSION(2), intent(in)   :: ds_child, ds_parent
-    REAL,    DIMENSION(                 &
-                indmin(1):indmax(1),    &
-                indmin(2):indmax(2)),           intent(out) :: tempP
-    REAL, DIMENSION(                            &
-                lb_child(1):ub_child(1),  &
-                lb_child(2):ub_child(2)), intent(in)  :: tempC
-!
-    REAL, DIMENSION(indmin(1):indmax(1), lb_child(2):ub_child(2)) :: tabtemp
-    INTEGER :: i
-!
-    do i = lb_child(2),ub_child(2)
-        call Agrif_Update_1D_Recursive(type_update(1),                              &
-                                       tabtemp(:, i),          &
-                                       tempC(:,i),  &
-                                       indmin(1),indmax(1),                 &
-                                       lb_child(1),ub_child(1),       &
-                                       s_child(1), s_parent(1),             &
-                                      ds_child(1),ds_parent(1))
-    enddo
-!
-    tempP = 0.
-!
-    do i = indmin(1),indmax(1)
-        call Agrif_UpdateBase(type_update(2),                                       &
-                              tempP(i,:),             &
-                              tabtemp(i,:), &
-                              indmin(2),indmax(2),                          &
-                              lb_child(2),ub_child(2),                &
-                              s_parent(2),s_child(2),                       &
-                             ds_parent(2),ds_child(2))
-    enddo
-!---------------------------------------------------------------------------------------------------
-end subroutine Agrif_Update_2D_Recursive_ok
 !===================================================================================================
 
@@ -1622,9 +1646,9 @@
 !! Calls #Agrif_Update_2D_Recursive and #Agrif_UpdateBase.
 !---------------------------------------------------------------------------------------------------
-subroutine Agrif_Update_3D_Recursive ( type_update,         &
-                                       tempP, tempC,        &
-                                       indmin, indmax,      &
-                                       lb_child, ub_child,  &
-                                        s_child,  s_parent, &
+subroutine Agrif_Update_3D_Recursive ( type_update,                     &
+                                       tempP, tempC, tempC_indic,       &
+                                       indmin, indmax,                  &
+                                       lb_child, ub_child,              &
+                                       s_child,  s_parent,              &
                                        ds_child, ds_parent )
 !---------------------------------------------------------------------------------------------------
@@ -1632,6 +1656,6 @@
     integer, dimension(3),          intent(in)  :: indmin, indmax
     integer, dimension(3),          intent(in)  :: lb_child, ub_child
-    real,    dimension(3),          intent(in)  ::  s_child,  s_parent
-    real,    dimension(3),          intent(in)  :: ds_child, ds_parent
+    real(kind=8),    dimension(3),          intent(in)  ::  s_child,  s_parent
+    real(kind=8),    dimension(3),          intent(in)  :: ds_child, ds_parent
     real,    dimension(          &
         indmin(1):indmax(1),     &
@@ -1641,5 +1665,5 @@
         lb_child(1):ub_child(1), &
         lb_child(2):ub_child(2), &
-        lb_child(3):ub_child(3)),   intent(in)  :: tempC
+        lb_child(3):ub_child(3)),   intent(in)  :: tempC, tempC_indic
 !---------------------------------------------------------------------------------------------------
     real, dimension(            &
@@ -1650,4 +1674,6 @@
     integer :: coeffraf,locind_child_left
     integer :: kuinf
+    REAL :: invcoeffraf
+    INTEGER :: diffmod, kk
 !
     coeffraf = nint ( ds_parent(1) / ds_child(1) )
@@ -1687,11 +1713,21 @@
     endif
 !
+ !   do k = lb_child(3),ub_child(3)
+ !       call Agrif_Update_2D_Recursive( type_update(1:2),tabtemp(:,:,k),tempC(:,:,k), &
+ !                                       indmin(1:2),indmax(1:2),                &
+ !                                       lb_child(1:2),ub_child(1:2),      &
+ !                                       s_child(1:2),s_parent(1:2),             &
+ !                                       ds_child(1:2),ds_parent(1:2) )
+ !   enddo
+
+
     do k = lb_child(3),ub_child(3)
-        call Agrif_Update_2D_Recursive( type_update(1:2),tabtemp(:,:,k),tempC(:,:,k), &
-                                        indmin(1:2),indmax(1:2),                &
-                                        lb_child(1:2),ub_child(1:2),      &
-                                        s_child(1:2),s_parent(1:2),             &
-                                        ds_child(1:2),ds_parent(1:2) )
+        call Agrif_Update_2D_Recursive( type_update,tabtemp(:,:,k),tempC(:,:,k),tempC_indic(:,:,k), &
+                                        indmin,indmax,                &
+                                        lb_child,ub_child,      &
+                                        s_child,s_parent,             &
+                                        ds_child,ds_parent)
     enddo
+
 !
     precomputedone(1) = .FALSE.
@@ -1711,6 +1747,50 @@
             enddo
         enddo
+    else if (type_update(3) == Agrif_Update_Copy) then
+    locind_child_left = lb_child(3) + nint((s_parent(3)-s_child(3))/ds_child(3))
+
+        do k=indmin(3),indmax(3)
+            do j = indmin(2),indmax(2)
+            do i = indmin(1),indmax(1)
+                tempP(i,j,k) = tabtemp(i,j,locind_child_left)
+            enddo
+            enddo
+            locind_child_left = locind_child_left + coeffraf
+        enddo
+    else if (type_update(3) == Agrif_Update_Average) then
+      invcoeffraf = 1./coeffraf
+      tempP = 0.
+      diffmod = 0
+      if (mod(coeffraf,2) == 0) diffmod=1 
+      locind_child_left = lb_child(3) + agrif_int((s_parent(3)-s_child(3))/ds_child(3))
+      if (Agrif_UseSpecialValueInUpdate) then
+        do k=indmin(3),indmax(3)
+          do kk=-coeffraf/2+locind_child_left+diffmod, &
+                   coeffraf/2+locind_child_left
+            do j=indmin(2),indmax(2)
+            do i=indmin(1),indmax(1)
+               if (tabtemp(i,j,kk) /= Agrif_SpecialValueFineGrid) then
+                  tempP(i,j,k) = tempP(i,j,k) + tabtemp(i,j,kk)
+               endif
+            enddo
+            enddo
+          enddo
+          locind_child_left = locind_child_left + coeffraf
+        enddo
+      else
+        do k=indmin(3),indmax(3)
+          do kk=-coeffraf/2+locind_child_left+diffmod, &
+                   coeffraf/2+locind_child_left
+            do j=indmin(2),indmax(2)
+            do i=indmin(1),indmax(1)
+                  tempP(i,j,k) = tempP(i,j,k) + tabtemp(i,j,kk)
+            enddo
+            enddo
+          enddo
+          locind_child_left = locind_child_left + coeffraf
+        enddo
+        if (.not.Agrif_Update_Weights) tempP = tempP * invcoeffraf
+      endif
     else
-        tempP = 0.
         do j = indmin(2),indmax(2)
         do i = indmin(1),indmax(1)
@@ -1720,7 +1800,9 @@
                                   s_parent(3),s_child(3),               &
                                   ds_parent(3),ds_child(3))
-!
+
         enddo
         enddo
+
+
     endif
 !---------------------------------------------------------------------------------------------------
@@ -1734,9 +1816,9 @@
 !! Calls #Agrif_Update_3D_Recursive and #Agrif_UpdateBase.
 !---------------------------------------------------------------------------------------------------
-subroutine Agrif_Update_4D_Recursive ( type_update,         &
-                                       tempP, tempC,        &
-                                       indmin, indmax,      &
-                                       lb_child, ub_child,  &
-                                        s_child,  s_parent, &
+subroutine Agrif_Update_4D_Recursive ( type_update,                     &
+                                       tempP, tempC, tempC_indic,       &
+                                       indmin, indmax,                  &
+                                       lb_child, ub_child,              &
+                                       s_child,  s_parent,              &
                                        ds_child, ds_parent )
 !---------------------------------------------------------------------------------------------------
@@ -1744,6 +1826,6 @@
     integer, dimension(4),          intent(in)  :: indmin, indmax
     integer, dimension(4),          intent(in)  :: lb_child, ub_child
-    real,    dimension(4),          intent(in)  ::  s_child,  s_parent
-    real,    dimension(4),          intent(in)  :: ds_child, ds_parent
+    real(kind=8),    dimension(4),          intent(in)  ::  s_child,  s_parent
+    real(kind=8),    dimension(4),          intent(in)  :: ds_child, ds_parent
     real,    dimension(          &
         indmin(1):indmax(1),     &
@@ -1755,5 +1837,5 @@
         lb_child(2):ub_child(2), &
         lb_child(3):ub_child(3), &
-        lb_child(4):ub_child(4)),   intent(in)  :: tempC
+        lb_child(4):ub_child(4)),   intent(in)  :: tempC, tempC_indic
 !---------------------------------------------------------------------------------------------------
     real, dimension(:,:,:,:), allocatable       :: tabtemp
@@ -1771,4 +1853,7 @@
                                                indmin(3):indmax(3), l),     &
                                        tempC(lb_child(1):ub_child(1),       &
+                                             lb_child(2):ub_child(2),       &
+                                             lb_child(3):ub_child(3), l),   &
+                                       tempC_indic(lb_child(1):ub_child(1),       &
                                              lb_child(2):ub_child(2),       &
                                              lb_child(3):ub_child(3), l),   &
@@ -1806,9 +1891,9 @@
 !! Calls #Agrif_Update_4D_Recursive and #Agrif_UpdateBase.
 !---------------------------------------------------------------------------------------------------
-subroutine Agrif_Update_5D_Recursive ( type_update,         &
-                                       tempP, tempC,        &
-                                       indmin, indmax,      &
-                                       lb_child, ub_child,  &
-                                        s_child,  s_parent, &
+subroutine Agrif_Update_5D_Recursive ( type_update,                     &
+                                       tempP, tempC, tempC_indic,       &
+                                       indmin, indmax,                  &
+                                       lb_child, ub_child,              &
+                                       s_child,  s_parent,              &
                                        ds_child, ds_parent )
 !---------------------------------------------------------------------------------------------------
@@ -1816,6 +1901,6 @@
     integer, dimension(5),          intent(in)  :: indmin, indmax
     integer, dimension(5),          intent(in)  :: lb_child, ub_child
-    real,    dimension(5),          intent(in)  ::  s_child,  s_parent
-    real,    dimension(5),          intent(in)  :: ds_child, ds_parent
+    real(kind=8),    dimension(5),          intent(in)  ::  s_child,  s_parent
+    real(kind=8),    dimension(5),          intent(in)  :: ds_child, ds_parent
     real,    dimension(          &
         indmin(1):indmax(1),     &
@@ -1829,5 +1914,5 @@
         lb_child(3):ub_child(3), &
         lb_child(4):ub_child(4), &
-        lb_child(5):ub_child(5)),   intent(in)  :: tempC
+        lb_child(5):ub_child(5)),   intent(in)  :: tempC, tempC_indic
 !---------------------------------------------------------------------------------------------------
     real, dimension(:,:,:,:,:), allocatable     :: tabtemp
@@ -1847,4 +1932,8 @@
                                                indmin(4):indmax(4), m),     &
                                        tempC(lb_child(1):ub_child(1),       &
+                                             lb_child(2):ub_child(2),       &
+                                             lb_child(3):ub_child(3),       &
+                                             lb_child(4):ub_child(4), m),   &
+                                       tempC_indic(lb_child(1):ub_child(1),       &
                                              lb_child(2):ub_child(2),       &
                                              lb_child(3):ub_child(3),       &
@@ -1885,9 +1974,9 @@
 !! Calls #Agrif_Update_5D_Recursive and #Agrif_UpdateBase.
 !---------------------------------------------------------------------------------------------------
-subroutine Agrif_Update_6D_Recursive ( type_update,         &
-                                       tempP, tempC,        &
-                                       indmin, indmax,      &
-                                       lb_child, ub_child,  &
-                                        s_child,  s_parent, &
+subroutine Agrif_Update_6D_Recursive ( type_update,                     &
+                                       tempP, tempC, tempC_indic,       &
+                                       indmin, indmax,                  &
+                                       lb_child, ub_child,              &
+                                       s_child,  s_parent,              &
                                        ds_child, ds_parent )
 !---------------------------------------------------------------------------------------------------
@@ -1895,6 +1984,6 @@
     integer, dimension(6),          intent(in)  :: indmin, indmax
     integer, dimension(6),          intent(in)  :: lb_child, ub_child
-    real,    dimension(6),          intent(in)  ::  s_child,  s_parent
-    real,    dimension(6),          intent(in)  :: ds_child, ds_parent
+    real(kind=8),    dimension(6),          intent(in)  ::  s_child,  s_parent
+    real(kind=8),    dimension(6),          intent(in)  :: ds_child, ds_parent
     real,    dimension(          &
         indmin(1):indmax(1),     &
@@ -1910,5 +1999,5 @@
         lb_child(4):ub_child(4), &
         lb_child(5):ub_child(5), &
-        lb_child(6):ub_child(6)),   intent(in)  :: tempC
+        lb_child(6):ub_child(6)),   intent(in)  :: tempC, tempC_indic
 !---------------------------------------------------------------------------------------------------
     real, dimension(:,:,:,:,:,:), allocatable   :: tabtemp
@@ -1930,4 +2019,9 @@
                                                indmin(5):indmax(5), n),     &
                                        tempC(lb_child(1):ub_child(1),       &
+                                             lb_child(2):ub_child(2),       &
+                                             lb_child(3):ub_child(3),       &
+                                             lb_child(4):ub_child(4),       &
+                                             lb_child(5):ub_child(5), n),   &
+                                       tempC_indic(lb_child(1):ub_child(1),       &
                                              lb_child(2):ub_child(2),       &
                                              lb_child(3):ub_child(3),       &
@@ -1982,6 +2076,6 @@
     real, dimension(indmin:indmax),     intent(out):: parent_tab
     real, dimension(lb_child:ub_child), intent(in) :: child_tab
-    real,                               intent(in) :: s_parent,  s_child
-    real,                               intent(in) :: ds_parent, ds_child
+    real(kind=8),                       intent(in) :: s_parent,  s_child
+    real(kind=8),                       intent(in) :: ds_parent, ds_child
 !---------------------------------------------------------------------------------------------------
     integer :: np       ! Length of parent array
Index: /vendors/AGRIF/CMEMS_2020/AGRIF_FILES/modupdatebasic.F90
===================================================================
--- /vendors/AGRIF/CMEMS_2020/AGRIF_FILES/modupdatebasic.F90	(revision 10086)
+++ /vendors/AGRIF/CMEMS_2020/AGRIF_FILES/modupdatebasic.F90	(revision 10087)
@@ -49,8 +49,8 @@
     integer,             intent(in)     :: np           !< Length of parent array
     integer,             intent(in)     :: nc           !< Length of child  array
-    real,                intent(in)     :: s_parent     !< Parent grid position (s_root = 0)
-    real,                intent(in)     :: s_child      !< Child  grid position (s_root = 0)
-    real,                intent(in)     :: ds_parent    !< Parent grid dx (ds_root = 1)
-    real,                intent(in)     :: ds_child     !< Child  grid dx (ds_root = 1)
+    real(kind=8),        intent(in)     :: s_parent     !< Parent grid position (s_root = 0)
+    real(kind=8),        intent(in)     :: s_child      !< Child  grid position (s_root = 0)
+    real(kind=8),        intent(in)     :: ds_parent    !< Parent grid dx (ds_root = 1)
+    real(kind=8),        intent(in)     :: ds_child     !< Child  grid dx (ds_root = 1)
 !---------------------------------------------------------------------------------------------------
     integer :: i, locind_child_left, coeffraf
@@ -84,8 +84,8 @@
     integer,             intent(in)     :: np           !< Length of parent array
     integer,             intent(in)     :: nc           !< Length of child  array
-    real,                intent(in)     :: s_parent     !< Parent grid position (s_root = 0)
-    real,                intent(in)     :: s_child      !< Child  grid position (s_root = 0)
-    real,                intent(in)     :: ds_parent    !< Parent grid dx (ds_root = 1)
-    real,                intent(in)     :: ds_child     !< Child  grid dx (ds_root = 1)
+    real(kind=8),        intent(in)     :: s_parent     !< Parent grid position (s_root = 0)
+    real(kind=8),        intent(in)     :: s_child      !< Child  grid position (s_root = 0)
+    real(kind=8),        intent(in)     :: ds_parent    !< Parent grid dx (ds_root = 1)
+    real(kind=8),        intent(in)     :: ds_child     !< Child  grid dx (ds_root = 1)
     integer,             intent(in)     :: dir          !< Direction
 !---------------------------------------------------------------------------------------------------
@@ -157,9 +157,10 @@
     REAL, DIMENSION(nc), intent(in)     :: y
     INTEGER,             intent(in)     :: np,nc
-    REAL,                intent(in)     :: s_parent,  s_child
-    REAL,                intent(in)     :: ds_parent, ds_child
+    REAL(kind=8),        intent(in)     :: s_parent,  s_child
+    REAL(kind=8),        intent(in)     :: ds_parent, ds_child
 !
     INTEGER :: i, ii, locind_child_left, coeffraf
-    REAL    :: xpos, invcoeffraf
+    REAL(kind=8)    :: xpos
+    REAL ::  invcoeffraf
     INTEGER :: nbnonnuls
     INTEGER :: diffmod
@@ -229,11 +230,11 @@
 !---------------------------------------------------------------------------------------------------
     INTEGER, intent(in) :: nc2, np, nc
-    REAL,    intent(in) :: s_parent,  s_child
-    REAL,    intent(in) :: ds_parent, ds_child
+    REAL(kind=8),    intent(in) :: s_parent,  s_child
+    REAL(kind=8),    intent(in) :: ds_parent, ds_child
     INTEGER, intent(in) :: dir
 !
     INTEGER, DIMENSION(:,:), ALLOCATABLE :: indchildaverage_tmp
     INTEGER :: i, locind_child_left, coeffraf
-    REAL    :: xpos
+    REAL(kind=8)    :: xpos
     INTEGER :: diffmod
 !
@@ -281,6 +282,6 @@
     REAL, DIMENSION(nc), intent(in)     :: y
     INTEGER,             intent(in)     :: np, nc
-    REAL,                intent(in)     :: s_parent,  s_child
-    REAL,                intent(in)     :: ds_parent, ds_child
+    REAL(kind=8),                intent(in)     :: s_parent,  s_child
+    REAL(kind=8),                intent(in)     :: ds_parent, ds_child
     INTEGER,             intent(in)     :: dir
 !
@@ -311,10 +312,9 @@
     ELSE
 !
-!CDIR NOLOOPCHG
-        do  j = 1,coeffraf
-!CDIR VECTOR
-            do i= 1,np
+
+        do i = 1,np
+        do j = 1,coeffraf
                 x(i) = x(i) + y(indchildaverage(i,dir) + j-1 )
-            enddo
+        enddo
         enddo
         IF (.not.Agrif_Update_Weights) THEN
@@ -338,8 +338,8 @@
     real, dimension(nc), intent(in)     :: y
     integer,             intent(in)     :: np, nc
-    real,                intent(in)     :: s_parent,  s_child
-    real,                intent(in)     :: ds_parent, ds_child
-!---------------------------------------------------------------------------------------------------
-    REAL    :: xpos, xposfin
+    real(kind=8),                intent(in)     :: s_parent,  s_child
+    real(kind=8),                intent(in)     :: ds_parent, ds_child
+!---------------------------------------------------------------------------------------------------
+    REAL(kind=8)    :: xpos, xposfin
     INTEGER :: i, ii, diffmod
     INTEGER :: it1, it2
